#ifndef CLEARPATH_ROS2_SOCKETCAN_INTERFACE__VISIBILITY_CONTROL_H_
#define CLEARPATH_ROS2_SOCKETCAN_INTERFACE__VISIBILITY_CONTROL_H_

// This logic was borrowed (then namespaced) from the examples on the gcc wiki:
//     https://gcc.gnu.org/wiki/Visibility

#if defined _WIN32 || defined __CYGWIN__
  #ifdef __GNUC__
    #define CLEARPATH_ROS2_SOCKETCAN_INTERFACE_EXPORT __attribute__ ((dllexport))
    #define CLEARPATH_ROS2_SOCKETCAN_INTERFACE_IMPORT __attribute__ ((dllimport))
  #else
    #define CLEARPATH_ROS2_SOCKETCAN_INTERFACE_EXPORT __declspec(dllexport)
    #define CLEARPATH_ROS2_SOCKETCAN_INTERFACE_IMPORT __declspec(dllimport)
  #endif
  #ifdef CLEARPATH_ROS2_SOCKETCAN_INTERFACE_BUILDING_LIBRARY
    #define CLEARPATH_ROS2_SOCKETCAN_INTERFACE_PUBLIC CLEARPATH_ROS2_SOCKETCAN_INTERFACE_EXPORT
  #else
    #define CLEARPATH_ROS2_SOCKETCAN_INTERFACE_PUBLIC CLEARPATH_ROS2_SOCKETCAN_INTERFACE_IMPORT
  #endif
  #define CLEARPATH_ROS2_SOCKETCAN_INTERFACE_PUBLIC_TYPE CLEARPATH_ROS2_SOCKETCAN_INTERFACE_PUBLIC
  #define CLEARPATH_ROS2_SOCKETCAN_INTERFACE_LOCAL
#else
  #define CLEARPATH_ROS2_SOCKETCAN_INTERFACE_EXPORT __attribute__ ((visibility("default")))
  #define CLEARPATH_ROS2_SOCKETCAN_INTERFACE_IMPORT
  #if __GNUC__ >= 4
    #define CLEARPATH_ROS2_SOCKETCAN_INTERFACE_PUBLIC __attribute__ ((visibility("default")))
    #define CLEARPATH_ROS2_SOCKETCAN_INTERFACE_LOCAL  __attribute__ ((visibility("hidden")))
  #else
    #define CLEARPATH_ROS2_SOCKETCAN_INTERFACE_PUBLIC
    #define CLEARPATH_ROS2_SOCKETCAN_INTERFACE_LOCAL
  #endif
  #define CLEARPATH_ROS2_SOCKETCAN_INTERFACE_PUBLIC_TYPE
#endif

#endif  // CLEARPATH_ROS2_SOCKETCAN_INTERFACE__VISIBILITY_CONTROL_H_
